#property copyright "MisterH"

#property indicator_separate_window
#property indicator_buffers  2
#property indicator_color1   Gray
#property indicator_color2   DarkOrange
#property indicator_color3   MediumSpringGreen
#property indicator_level1  0
#property indicator_levelcolor DarkSlateGray

double oscillator[];
double smoother[];
double periods[]={3,5,8,10,12,15,30,35,40,45,50,60};
int    persize;
extern int smootherlength=8;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
int init()
{
   SetIndexBuffer(0,oscillator);
   SetIndexBuffer(1,smoother);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   
   persize =ArraySize(periods);
   return(0);
}
int deinit() { return(0); }

int start()
{
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
         limit = Bars-counted_bars;

   for(i=limit; i>=0; i--)
   {
      double sum  = 0;

      for(int j=0; j<persize; j++)
      {
         if (periods[j]<30)
               sum  += iMA(NULL,0,periods[j],0,MODE_EMA,0,i);
         else  sum  -= iMA(NULL,0,periods[j],0,MODE_EMA,0,i);
      }
      oscillator[i] = sum*10.0;
   }
   
   for(i=limit; i>=0; i--)
   {
   smoother[i] =iMAOnArray(oscillator,0,smootherlength,0,3,i)-iMAOnArray(oscillator,0,smootherlength,0,2,i);
   }
   
  return(0);
}