//+-------------------------------------------------------------------------------------+
//|  only draws the line after completion; no repainting, but obviously a little slow.. |
//+-------------------------------------------------------------------------------------+

#property copyright "MisterH"
//#property library           // to make library
//#property stacksize   1024
//------- property directives for scripts:
/*
#property show_confirm // void type
#property show_inputs  // void type
*/
#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 Aqua
#property indicator_width1 1
#property indicator_color2 Aqua
#property indicator_width2 1

//+------------------------------------------------------------------+
//| Defines                                                          |
//+------------------------------------------------------------------+
#define DBL_EPSILON 0.0000000000000002220446049250314

//+------------------------------------------------------------------+
//| Input parameters                                                 |
//+------------------------------------------------------------------+
extern int Candle = 1000;
extern int Win_Length = 8;
extern int Sm_Length = 0;
extern bool ShowZZorNBars = false;
extern bool CountOnlyRightDir = true;
extern bool ResetOnSmTurn = false;

//+------------------------------------------------------------------+
//| Global variables and arrays                                      |
//+------------------------------------------------------------------+
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ZigZagBuf[], SwingBuf[];
double BHBuf[], BLBuf[];
double BarsCountBuf[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   IndicatorBuffers(7);
   if (ShowZZorNBars) IndicatorDigits(Digits); else IndicatorDigits(0);
   //-------------------
   SetIndexEmptyValue(1, 0);
   SetIndexStyle(1,DRAW_SECTION);
   SetIndexBuffer(1,ExtMapBuffer1);   
   SetIndexLabel(1,"ZZ buffer");
   //-------------------
   SetIndexBuffer(0,ExtMapBuffer2);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexLabel(0,"Bars to previous extreme");
   //------   
   SetIndexBuffer(2, ZigZagBuf);
   SetIndexEmptyValue(2, 0);
   SetIndexBuffer(3, BarsCountBuf);
   SetIndexBuffer(4, SwingBuf);
   SetIndexEmptyValue(4, 0);
   SetIndexBuffer(5, BHBuf);
   SetIndexBuffer(6, BLBuf);
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {
   return(0);
  }


//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+
int start()
  {
   int limit;
   int counted_bars = IndicatorCounted();
   //---- last calculated bar will be recalculated
   if(counted_bars > 0) counted_bars--;
   limit = Bars-counted_bars;
   if (limit > Candle) limit = Candle;
   //----------------------------------------
   int i, shift;
   int zu,zd;
   double LL,HH; 
   int iDir;
   double dExtr;
   //--------------------------------------
   for(shift=limit; shift>=1; shift--)
      { 
      LL = 100000000;                                                         //for storing previous minimum
      HH = -100000000;                                                        //for storing previous maximum
      for (i=shift+Win_Length; i>=shift+1; i--)                                   //scanning history with depth = Length from the current bar
         {
         if (cmp(fGetValue(i),LL) < 0) LL = fGetValue(i);                     //we are looking for local minimum
         if (cmp(fGetValue(i),HH) > 0) HH = fGetValue(i);                     //.. and maximum
         }
      
      SwingBuf[shift] = SwingBuf[shift+1];                                    //by default Swing buffer gets its previous value
      
      if (cmp(fGetValue(shift),LL) < 0) SwingBuf[shift] = -1;                 //.. but if current value is lower than LL - we are at downward swing
      if (cmp(fGetValue(shift),HH) > 0) SwingBuf[shift] = 1;                  //.. or if current value is higher than HH - we are at upward swing
      
      if (BHBuf[shift+1] != EMPTY_VALUE) BHBuf[shift] = BHBuf[shift+1] + 1;   //BH buffer measures distance from last potential maximum, increases by 1 every bar
      if (BLBuf[shift+1] != EMPTY_VALUE) BLBuf[shift] = BLBuf[shift+1] + 1;   //BL buffer measures distance from the last potential minimum, increases by 1 every bar
      
      if (SwingBuf[shift] != SwingBuf[shift+1] && SwingBuf[shift+1] != 0)     //this is the condition for appearing new one segment of ZZ - changing of Swing sign
         {         
         if (SwingBuf[shift] == 1)                                            //if we enter into upward swing, the last desceding segment of ZZ will be completed
            {            
            zd = shift+BLBuf[shift];                                          //get index of the bar with last mininum
            ZigZagBuf[zd] = fGetValue(zd);                                    //store value into temporary buffer
            if (ShowZZorNBars) ExtMapBuffer1[zd] = ZigZagBuf[zd];             //copy value to visualizing buffer if necessary
            BHBuf[shift] = 0;                                                 //BH distance is zero - current bar is new potential maximum
            }
         if (SwingBuf[shift] == -1)                                           //the same....
            {            
            zu = shift+BHBuf[shift];
            ZigZagBuf[zu] = fGetValue(zu);
            if (ShowZZorNBars) ExtMapBuffer1[zu] = ZigZagBuf[zu];
            BLBuf[shift] = 0; 
            }
         }
      
      if (SwingBuf[shift] == 1)                                               //potential maximum can be overwritten with new high, in that case BH distance is reseted
         if(cmp(fGetValue(shift),fGetValue(shift+BHBuf[shift])) >= 0)
            BHBuf[shift] = 0;

      if (SwingBuf[shift] == -1)                                              //potential minimum can be overwritten with new low, in that case BL distance is reseted
         if(cmp(fGetValue(shift),fGetValue(shift+BLBuf[shift])) <= 0)
            BLBuf[shift] = 0;
   
      if (!ShowZZorNBars)                                                        //this part plots #BarsSinceLastZZ chart
         {
         iDir = 0;
         for (int j = shift + MathMax(BLBuf[shift], BHBuf[shift]); j >= shift; j--) //scanning history for local extremums
            {
            if(ZigZagBuf[j] != 0.0)
               {
               if (BHBuf[j] == 0) iDir = -1;                                        //store extremum type in iDir variable
               if (BLBuf[j] == 0) iDir =  1;                                        //...
               dExtr = ZigZagBuf[j];
               BarsCountBuf[j] = 1.0;                                              //resetting NumBars               
               }
            else
               if (BarsCountBuf[j+1] != EMPTY_VALUE) BarsCountBuf[j] = BarsCountBuf[j+1] + 1;

            if (!CountOnlyRightDir)                                           //if we don't take in consideration direction of price movement
               ExtMapBuffer2[j] = BarsCountBuf[j];                            //just increase counter
            else                                                              //otherwise, increase only under certain conditions
               {
               if((cmp(fGetValue(j), dExtr) < 0 && iDir == -1) || (cmp(fGetValue(j), dExtr) > 0 && iDir == 1) || BarsCountBuf[j] == 1)
                  {
                  dExtr = fGetValue(j);
                  ExtMapBuffer2[j] = BarsCountBuf[j];
                  }
               else
                  {
                  ExtMapBuffer2[j] = ExtMapBuffer2[j+1];
                  if (ResetOnSmTurn)                                          //reset based on smoother movement direction at the flat part
                     if ((cmp(fGetValue2(j), fGetValue2(j+1)) > 0 && iDir == -1) || (cmp(fGetValue2(j), fGetValue2(j+1)) < 0 && iDir == 1))
                        {
                        BarsCountBuf[j] = 1.0;
                        ExtMapBuffer2[j] = BarsCountBuf[j];
                        dExtr = fGetValue(j);
                        }                        
                  }
               }
            }
         } 
      Comment("Bars from the last extremum: ",DoubleToStr(ExtMapBuffer2[0],0));
      }      
   //------
   return(0);
   }
//####################################################################

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
 int cmp(double d1, double d2, double range=0.0)
  {
   if(range < 2*DBL_EPSILON)
      range = 2*DBL_EPSILON;
   
   if(MathAbs(d1-d2) < range)
      return(0);
   
   if(d1 > d2)
      return(1);
   return(-1);
  }
//+------------------------------------------------------------------+
//| Returns value on which ZigZag is calculated                      |
//+------------------------------------------------------------------+
double fGetValue(int iparPos)
   {
   double dRetVal;
   //dRetVal = Close[iparPos];
   dRetVal = iCustom(NULL, 0, "# another oscillator vii", Sm_Length, 0, iparPos);
   return(dRetVal);
   }
//+------------------------------------------------------------------+
//| Returns value for resetting counter in ResetOnSmTurn Mode        |
//+------------------------------------------------------------------+
double fGetValue2(int iparPos)
   {
   double dRetVal;
   dRetVal = iCustom(NULL, 0, "# another oscillator vii", Sm_Length, 1, iparPos);
   return(dRetVal);
   }